#ifndef _GPIO_H_
#define _GPIO_H_
#ifdef __cplusplus
extern "C" {
#endif
#include "../FreeRTOS/FreeRTOS.h"

typedef struct S_pinreg{
	unsigned long P0:1;
	unsigned long P1:1;
	unsigned long P2:1;
	unsigned long P3:1;
	unsigned long P4:1;
	unsigned long P5:1;
	unsigned long P6:1;
	unsigned long P7:1;
	unsigned long P8:1;
	unsigned long P9:1;
	unsigned long P10:1;
	unsigned long P11:1;
	unsigned long P12:1;
	unsigned long P13:1;
	unsigned long P14:1;
	unsigned long P15:1;
	unsigned long P16:1;
	unsigned long P17:1;
	unsigned long P18:1;
	unsigned long P19:1;
	unsigned long P20:1;
	unsigned long P21:1;
	unsigned long P22:1;
	unsigned long P23:1;
	unsigned long P24:1;
	unsigned long P25:1;
	unsigned long P26:1;
	unsigned long P27:1;
	unsigned long P28:1;
	unsigned long P29:1;
	unsigned long P30:1;
	unsigned long P31:1;
}S_pinreg;

typedef struct S_gpio{
	 union{
			unsigned long ioState;
			struct S_pinreg ioPinState;
	};
	union{
		 	 unsigned long ioSet;
		 	struct S_pinreg ioPinSet;
	};
	union{
			unsigned long ioDir;
			struct S_pinreg ioPinDir;
	};
	union{
			unsigned long ioClr;
			struct S_pinreg ioPinClr;
	};
}S_gpio;


#define GPIO0 (* (S_gpio *) 0xE0028000)

#ifdef __cplusplus
}
#endif
#endif
